/*
 * hfcddwwn.h
 *
 * Copyright (C) 2007, Hitachi, Ltd.
 * Author(s): Yoshihiro Toyohara <yoshihiro.toyohara.qs@hitachi.com>
 *
 */

/*
 * $Id: hfcddwwn.h,v 1.4.8.6 2007/12/12 02:53:57 eteshima Exp $ 
 */
 
#ifndef _H_HFCDDWWN
#define _H_HFCDDWWN

 
/* ioctl command */ 
/*************************************************************************/
/* Attention !!                                                          */
/* Originally, it is necessary to define ioctl command with hfclddioc.h. */
/*************************************************************************/
#define HFC_IOC_MAGIC   'F'
#define IOCTL_HFC_WWN_INFO  _IOWR(HFC_IOC_MAGIC,20,struct hfc_ioctl_wwn) 



#define MAX_PARTITION   1       /* Max lpar count                           */
#define MAX_PRIORITY    8       /* Max boot Priority                        */ 

struct hfc_ioctl_wwn {
    uchar       version ;       /* this sturucture version                  */
#define VERSION_0       0       /*   Version 0 only                         */

    uchar       command ;       /*                                          */
#define GET_WWN_INFO    1       /* Get wwn & boot infomation                */
#define PUT_WWN_INFO    2       /* Put wwn infomation                       */
#define PUT_BOOT_INFO   3       /* Put boot infomation                      */
#define PUT_WWNBT_INFO  4       /* Put wwn & boot infomation                */
#define CLEAR_WWN_INFO  10      /* Clear wwn infomation                     */
#define CLEAR_BOOT_INFO 11      /* Clear boot infomation                    */
    ushort      resp_code ;
#define NORMAL_END      0x0000
#define IOCTL_WWN_BUSY  0x0001
#define IOCTL_WWN_ERR   0xFF00
    uchar       bios_enable ;
#define BIOS_ENABLE     1       /* HBA-BIOS Enable                          */
#define BIOS_DISABLE    0       /* HBA-BIOS Disable                         */
    uchar     resv0[3] ;

    uint64_t    orgWWPN ;       /* World Wide Port Name(original)           */
    uint64_t    orgWWNN ;       /* World Wide Node Name(original)           */

#define MODEL_NAME_LENGTH 16								/* FCLNX-0329 */
    uchar       model_name[MODEL_NAME_LENGTH] ;/* HBA model_name            */
    uint        fw_version ;    /* adapter F/W version                      */
    uchar       location[3] ;   /* Bus,Dev,Func                             */
    uchar       rsrv1;
    struct {
        uint64_t    addWWPN ;                   /* World Wide Port Name(additional) */
        uint64_t    addWWNN ;                   /* World Wide Node Name(additional) */
        uint64_t    targetWWN[MAX_PRIORITY] ;   /* Boot device wwn                  */
        ushort      targetLUN[MAX_PRIORITY] ;   /* boot device lun                  */
        uchar       rsrv2[6*MAX_PRIORITY];
    } add_info[MAX_PARTITION];
};

struct cr_PartsNumber {							/* FCLNX-0329 */
	uchar	pk_code;							/* package code */
	uchar	pk_port;							/* port num */
	ushort	wk;
	char	header[4];							/* Parts Number char0 */
	char	pk[4];								/* Parts Number char6 */
	char	hwinf[4];							/* Parts Number char9,10 */
	char	model_name[MODEL_NAME_LENGTH];		/* modele name */
};


#endif /* _H_HFCDDWWN */
