/*
 * hfcl_detect.h
 * Copyright (C) 2007, Hitachi, Ltd.
 * Author(s): Yoshihiro Toyohara <yoshihiro.toyohara.qs@hitachi.com>
 */
/*
 * $Id: hfcl_detect.h,v 1.16.2.8.2.2 2008/04/17 12:44:46 eteshima Exp $
 */


#ifndef _H_HFCL_DETECT
#define _H_HFCL_DETECT

#define HFC_ALIGN08( _AAA ) (((_AAA)+0x7) & ~0x7)
#define HFC_ALIGN16( _AAA ) (((_AAA)+0xF) & ~0xF)
#define HFC_ALIGNPG( _AAA ) ((((_AAA)+(HFC_PAGE_SIZE-1))/HFC_PAGE_SIZE)*HFC_PAGE_SIZE)

extern int __devinit hfc_probe_one(struct pci_dev *pdev, const struct pci_device_id *id);
extern void __devexit hfc_remove_one(struct pci_dev *pdev);
extern int hfc_biosparam(struct scsi_device *sdev, struct block_device *bdev, sector_t capacity, int geom[]);

extern int hfc_proc_info_k26(struct Scsi_Host *host, char *buffer, char **start, off_t offset, int length, int inout);
extern int hfc_release(struct Scsi_Host *host);
extern const char *hfc_info(struct Scsi_Host *host);

extern int hfc_clear_target_info( struct adap_info *ap, struct target_info *target, int check, int pmsg );

extern int hfc_attach(struct adap_info *ap);
extern int hfc_pci_conf(struct adap_info *ap);

extern int hfc_allocate_dma(struct adap_info *ap);
extern int hfc_free_dma(struct adap_info *ap);

extern int hfc_query_pktype(struct adap_info *ap);
extern int hfc_start_adapter(struct adap_info *ap);

extern void hfc_get_bindtid(struct adap_info *ap);
extern int hfc_initialize(struct adap_info *ap, int immdt_cmd);
extern int hfc_check_inta(struct adap_info *ap);

extern int hfc_config_hw_set(struct adap_info *ap, uint retry_maxcnt);
extern int hfc_config_hw_set_five(struct adap_info *ap, uint retry_maxcnt);

extern void hfc_wwnverify_linkup (struct adap_info *ap, struct target_info *target, uint mb_resp_status, uint64_t ww_name);
extern void hfc_wwnverify_linkup_timeout(struct adap_info *ap, struct target_info *target, uint mb_resp_status);
extern void hfc_wwnverify_gidft(struct adap_info *ap, struct target_info *target, uint mb_resp_status);
extern void hfc_wwnverify_gpnid(struct adap_info *ap, struct target_info *target, uint mb_resp_status);
extern void hfc_wwnverify_login(struct adap_info *ap, struct target_info *target, uint mb_resp_status, uint64_t ww_name);
extern void hfc_wwnverify_scn(struct adap_info *ap, struct target_info *target, uint mb_resp_status);

extern struct target_info *hfc_add_target_info( struct adap_info *ap, uint64_t scsi_id );


extern int hfc_chk_conf_val(int min, int max, int val);
extern int hfc_chk_conf_ls(int min, int max, int val);
extern int hfc_chk_conf_mt(int min, int max, int val);

extern void hfc_conf_setup(struct adap_info *ap);

extern void hfc_set_topology(struct adap_info *ap);
extern void hfc_set_linkspeed(struct adap_info *ap);
extern void hfc_set_max_transfer(struct adap_info *ap);
extern void hfc_set_linkup_tmo(struct adap_info *ap);
extern void hfc_set_reset_delay(struct adap_info *ap);
extern void hfc_set_mck_count(struct adap_info *ap);
extern void hfc_set_pref_alpa(struct adap_info *ap);
extern void hfc_set_target_timeout(struct adap_info *ap);
extern void hfc_set_abort_timeout(struct adap_info *ap);
extern void hfc_set_seg_trace(struct adap_info *ap);
extern void hfc_set_queue_depth(struct adap_info *ap);
extern void hfc_set_enable_target_reset(struct adap_info *ap);
extern void hfc_set_max_target(struct adap_info *ap);
extern void hfc_set_xob_max(struct adap_info *ap);
extern void hfc_set_xrb_max(struct adap_info *ap);
extern void hfc_set_slog_max(struct adap_info *ap);
extern void hfc_set_trc_max(struct adap_info *ap);
extern void hfc_set_pkt_num(struct adap_info *ap);
extern void hfc_set_can_queue(struct adap_info *ap);
extern void hfc_set_sg_tblsize(struct adap_info *ap);
extern void hfc_set_cmnd_num(struct adap_info *ap);
extern void hfc_set_minus_tout(struct adap_info *ap);
extern void hfc_set_scsi_allowed(struct adap_info *ap);
extern void hfc_set_cmd_per_lun(struct adap_info *ap);
extern void hfc_set_max_sectors(struct adap_info *ap);
extern void hfc_set_vary_io(struct adap_info *ap);

extern int hfc_search_adapter_number(struct adap_info *ap);
extern int hfc_get_adapter_bindings(void);
extern int hfc_get_target_bindings(struct adap_info *ap);
extern char hfc_cnvc(char C);
extern int hfc_parse_string(char *string, char *keyword, uint64_t *value);
extern int hfc_convert_string(char *string, uint64_t *value);
extern char *hfc_get_write_retries(void);
extern void hfc_set_pub_symbol_list(void);
extern int hfc_check_nonpub_symbol(void);

extern void hfc_free_mpap(struct adap_info *ap);
extern int hfc_probe_internal(struct adap_info *ap);
extern int hfc_remove_internal(struct adap_info *ap);

extern void hfc_param_setup(void);
extern int hfc_param_search(char *search_str, int *value);

#if 0																								/* FC-GW */
extern void hfc_rport_add(struct adap_info *ap, struct target_info *target);						/* FC-GW */
extern void hfc_rport_delete(struct target_info *target);											/* FC-GW */
#endif																								/* FC-GW */
extern void hfc_reset_all_timer (struct adap_info *ap);

#endif                          /* !INCLUDE_HFCDETECT */
